<template>
    <Form @submit="onSubmit" :validation-schema="schema" v-slot="{setFieldValue, values}">
      <b-card
        no-body
        class="mb-0 table-card table-hover table-custom-striped p-1"
      >
      <b-row>
        {{ currentValue(values) }}
        <b-col cols="12" md="5" class="px-1 form-card form-group mb-0">
            <TextInput
            ref="firstInput"
            name="name" 
            label="Role Name"
            type="text"
            placeholder="Enter Role Name"
            v-model="nameasd"
            :disabled="pageType == 'view'"
            :maxlength="30"
            :autofocus="true"
            @change="e=> nameasd = e"
            >
            </TextInput>
        </b-col>
      </b-row>
        <table class="table permission-table m-0 table-cus">
          <thead>
            <th class="bg-white pl-0">
              <h4 class="module-title module-head-text">Modules</h4>
            </th>
            <th colspan="6" class="text-left bg-white">
              <h4 class="module-head-text">Permissions</h4>
            </th>
          </thead>
          <tbody>
            <template v-for="permissionOption in permissionOptions">
              <tr>
                <td>
                  <p class="module-title mb-0">
                    {{ permissionOption.module }}
                  </p>
                </td>
                <template v-for="permission in permissionOption.permissions" v-bind:key="permission">
                  <td>
                    <CheckboxInput 
                          :disabled="pageType == 'view' || permission.is_active == false"
                          :value=" permission.is_active == true
                          ? isPermission(permission.value)
                          : false"
                          :name="permission.value"
                          label=""
                          :isSwitch="false"
                          :innerLabel="permission.text"
                          @change="permissionChange(permission, $event, permissionOption)"
                          >
                          </CheckboxInput>
                    <!-- <b-form-checkbox
                      :disabled="pageType == 'view' || permission.is_active == false"
                      :checked="
                        permission.is_active == true
                          ? isPermission(permission.value)
                          : false
                      "
                      name="permissions[]"
                      :id="permission.value"
                      inline
                      @change="permissionChange(permission, $event, permissionOption)"
                    >
                      {{ permission.text }}
                    </b-form-checkbox> -->
                  </td>
                </template>
                <td>
                  <template v-if="permissionOption.more_permissions.length != 0">
                    <b-dropdown text="" variant="link" right no-caret class="more-tab">
                      <template #button-content>
                        <span class="ml-50 text-body float-left font-700">More</span>
                        <b-img :src="downArrowIcon" class="text-body float-right" />
                      </template>
                      <b-dropdown-form>
                        <template
                          v-for="more_permission in permissionOption.more_permissions" v-bind:key="more_permission.text"
                        >

                        <CheckboxInput 
                          :disabled="pageType == 'view' || more_permission.is_active == false"
                          :value="more_permission.is_active == true
                                ? isPermission(more_permission.value)
                                : false"
                          
                          :name="more_permission.value"
                          label=""
                          :isSwitch="false"
                          :innerLabel="more_permission.text"
                          @change="permissionChange(more_permission, $event, permissionOption)"
                          >
                          </CheckboxInput>
                          <!-- <b-form-checkbox
                            :disabled="
                              pageType == 'view' || more_permission.is_active == false
                            "
                            :checked="
                              more_permission.is_active == true
                                ? isPermission(more_permission.value)
                                : false
                            "
                            name="more_permission[]"
                            :id="more_permission.value"
                            inline
                            @change="
                              permissionChange(more_permission, $event, permissionOption)
                            "
                          >
                            {{ more_permission.text }}
                          </b-form-checkbox> -->
                        </template>
                      </b-dropdown-form>
                    </b-dropdown>
                  </template>
                </td>
              </tr>
            </template>
          </tbody>
        </table>
      </b-card>

      <b-row class="mt-2">
        <b-col cols="12" md="6" class="px-4">
          <div class="d-flex form-status">
           
            <CheckboxInput 
            :disabled="pageType == 'view'"
            class="status-switch"
            :value="status"
            switch
            name="status"
            label="Status"
            @change="e => status = e">

            </CheckboxInput>
          </div>
        </b-col>
        <b-col cols="12" md="6" class="px-4 text-right">
          <b-button
            class="btn-reset"
            variant="flat-secondary"
            type="button"
            v-if="pageType != 'view'"
            @click="getModelData"
          >
            Reset
          </b-button>
          <b-button
            class="btn-submit-edit"
            v-if="pageType != 'view'"
            variant="primary"
            type="submit"
            :disabled="isSubmit"
          >
            <b-spinner small v-if="isSubmit" />
            Save
          </b-button>
          <b-button
            class="btn-submit-edit"
            v-if="pageType == 'view'  && ability.can('read', 'roles_edit')"
            variant="primary"
            type="submit"
            @click.prevent="changeMode(id)"
          >
            <b-spinner small v-if="isSubmit" />
            Edit
          </b-button>
        </b-col>
      </b-row>
      </Form>
</template>
<script>
import {
  BImg,
  BCard,
  BRow,
  BCol,
  BAlert,
  BFormInput,
  BButton,
  BTable,
  BLink,
  BBadge,
  BFormGroup,
  BForm,
  BCardBody,
  BCardHeader,
  BCardFooter,
  BCardTitle,
  BFormCheckbox,
  BFormCheckboxGroup,
  BSpinner,
  BDropdown,
  BDropdownItem,
  BDropdownForm,
  BModal
} from "bootstrap-vue";
import { useRoute } from 'vue-router'
import store from "@/store";
import { ref, onUnmounted, computed, toRaw } from "vue";
import roleService from "./service";
import Ripple from "vue-ripple-directive";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import { useToast } from "vue-toastification";
import { Form, useForm, ErrorMessage, Field } from 'vee-validate';
import * as yup from 'yup';
import ability from "@/libs/acl/ability";

const toast = useToast();

export default {
  components: {
    BImg,
    BCard,
    BRow,
    BCol,
    BAlert,
    BFormInput,
    BButton,
    BTable,
    BLink,
    BBadge,
    BFormGroup,
    BForm,
    BCardHeader,
    BCardTitle,
    BFormCheckbox,
    BCardBody,
    BCardFooter,
    BFormCheckboxGroup,
    BSpinner,
    BDropdown,
    BDropdownItem,
    BDropdownForm,
    BModal,
    Form,
    Field,
    ErrorMessage
  },
  directives: {
    Ripple,
  },
  setup() {
    const MODULE_NAME = "role";

   
    if (!store.hasModule(MODULE_NAME)) store.registerModule(MODULE_NAME, roleService);

    // UnRegister on leave
    onUnmounted(() => {
      // if (store.hasModule(MODULE_NAME)) store.unregisterModule(MODULE_NAME);
    });
  
   
    return {
    
    }
  },
  data() {
    return {
      currentValueSnap: {},
      formLoaded: false,
      downArrowIcon: new URL("/src/assets/images/icons/down-arrow.svg", import.meta.url).href,
      pageType: this.$route.meta.type,
      nameasd: "",
      id: "",
      status: "",
      isSubmit: false,
      permissionOptions: [],
      permissionsSelected: [],
      ability,
    };
  },
  computed: {
    schema() {
      return yup.object({
      name: yup.string().required("Please enter Role Name"),
      status: yup.boolean()
    });
    },
    
  },
  beforeUnmount(){
  },
  mounted() {
    setTimeout(() => {
      this.formLoaded = true;
    }, 1500);
    const router = useRoute()
    this.id = router?.params?.id;
    console.log(this.id, 'this.idthis.id')
    this.getModelData();
  },
  methods: {
    currentValue(values) {
      if (!this.formLoaded) {
        console.log(values, 'valuesvaluesvaluesvaluesvaluesvalues')
        this.currentValueSnap = JSON.parse(JSON.stringify(values));
      }
      return '';
    },
    resetForm(setFieldValue) {
      console.log(this.currentValueSnap,setFieldValue, 'currentValueSnapcurrentValueSnapcurrentValueSnap')
      for(let key in this.currentValueSnap) {
        console.log(key, this.currentValueSnap[key],'currentValueSnapcurrentValueSnapcurrentValueSnap')
        setFieldValue(key, this.currentValueSnap[key]);
      }
      
    },
    onInvalidSubmit(values) {
      
    },
    onSubmit(values, { setErrors }) {
      console.log(values);
          var data = {
            name: values.name,
            status: values.status,
            permissions: this.permissionsSelected,
          };
          if (this.id) {
            data = {
              id: this.id,
              name: values.name,
              status: values.status,
              permissions: this.permissionsSelected,
            };
          }
          this.isSubmit = true;
          const appLoading = document.getElementById("loading-bg");
          if (appLoading) {
            appLoading.style.display = "block";
          }
          store
            .dispatch("role/save", data)
            .then((response) => {
              if (response.data.status == true) {
                this.$router
                  .push({
                    name: "role-list",
                  })
                  .then(() => {
                    this.showToast(
                      "success",
                      "CheckCircleIcon",
                      response.data.title,
                      response.data.message
                    );
                    this.isSubmit = false;
                  });
              } else {
                if (response.data.errors) {
                    setErrors(response.data.errors);
                } else {
                  this.showToast(
                    "danger",
                    "AlertCircleIcon",
                    response.data.title,
                    response.data.message
                  );
                }
                this.isSubmit = false;
              }
              appLoading.style.display = "none";
            })
            .catch(() => {
              this.isSubmit = false;
              appLoading.style.display = "none";
            });
    },
    changeMode(id) {
      this.$router.push({ name: "role-edit", params: { id: id } }).then(() => {
        this.getModelData();
      });
    },
    getModelData() {
      // this.resetForm();
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      store
        .dispatch("role/permissionList")
        .then((response) => {
          const data = response.data.result;
          this.permissionOptions = data.permissions;
          // this.permissionOptions.forEach((permissionsOption) => {
          //   permissionsOption.permissions.forEach((permission, index) => {
          //     if (index == 0) {
          //       this.permissionsSelected.push(permission.value);
          //     }
          //   });
          // });
          appLoading.style.display = "none";
        })
        .catch(() => {
          appLoading.style.display = "none";
        });

        if (this.id) {
        this.isEditUser = true;
        const appLoading = document.getElementById("loading-bg");
        if (appLoading) {
          appLoading.style.display = "block";
        }
        store
          .dispatch("role/edit", { id: this.id })
          .then((response) => {
            this.pageType = this.$route.meta.type;
            const data = response.data.result;
            this.id = data.id;
            this.nameasd = data.name;
            this.status = data.status == 1 ? true : false;
            this.permissionsSelected = response.data.result.permissions;
            setValues ? setValues({name: this.nameasd, status: this.status}) : null;
            appLoading.style.display = "none";
            setTimeout(() => {
              this.$refs.firstInput.$refs.input.focus();
            }, 100);
          })
          .catch((error) => {
            appLoading.style.display = "none";
          });
      } else {
        this.id = "";
        this.nameasd = "";
        this.status = true;
        this.permissionsSelected = [];
      }
    },
    // resetForm() {
    //   this.nameasd = "";
    //   this.permissionsSelected = [];
    // },
   
    showToast(variant, icon, title, message) {
      toast({
        component: ToastificationContent,
        props: {
          title: title,
          icon,
          text: message,
          variant,
        },
      });
    },
    checkBoxValueChange(e, type) {
      if (type == "status") {
        status = e;
      }
    },
    isPermission(value) {
      if (this.permissionsSelected.includes(value)) {
        return true;
      } else {
        return false;
      }
    },
    permissionChange(permission, event, perOption) {
      if (!this.permissionsSelected.includes(permission.value)) {
        this.permissionsSelected.push(permission.value);
      }

      if (permission.text != "View") {
        if (!this.permissionsSelected.includes(permission.module + "_view")) {
          this.permissionsSelected.push(permission.module + "_view");
        }
      }

      if (permission.text == "View") {
        if (!event) {
          var modulePermission = this.permissionOptions.filter(function (elem) {
            if (elem.module == perOption.module) {
              return elem;
            }
          });
          const per = modulePermission[0]?.permissions;
          if (per && per.length > 0) {
            for (var i = 0; i < per.length; i++) {
              if (this.permissionsSelected.includes(per[i].value)) {
                var index = this.permissionsSelected.indexOf(per[i].value);
                this.permissionsSelected.splice(index, 1);
              }
            }
          }

          const mPer = modulePermission[0]?.more_permissions;
          if (mPer && mPer.length > 0) {
            for (var m = 0; m < mPer.length; m++) {
              if (this.permissionsSelected.includes(mPer[m].value)) {
                var index = this.permissionsSelected.indexOf(mPer[m].value);
                this.permissionsSelected.splice(index, 1);
              }
            }
          }
        }
      }

      if (!event) {
        if (this.permissionsSelected.includes(permission.value)) {
          var index = this.permissionsSelected.indexOf(permission.value);
          this.permissionsSelected.splice(index, 1);
        }
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}

</style>
